<template>
  <v-card light>
    <v-card-title>Update Todo</v-card-title>
    <hr class="mx-3" />
    <v-card-text>
        <v-form
            ref="form"
            lazy-validation>
            <v-text-field 
                label="Title" 
                v-model="formData.title"
                required
                :rules="[v => !!v || 'Title is required']"></v-text-field>
            <v-text-field 
                label="Description" 
                v-model="formData.description"></v-text-field>
            <v-select 
                label="Status" 
                v-model="status"
                :items="items"
                item-text="text"
                item-value="value"
                required
                :rules="[v => !!v || 'Status is required']">
            </v-select>
        </v-form>
    </v-card-text>
    <v-card-actions class="justify-end">
        <v-btn 
            class="btn-primary mx-1" 
            :loading="loading"
            @click="updateData">Save</v-btn>
        <v-btn 
            class="btn-secondary mx-1" 
            :loading="loading"
            @click="closeThis">Close</v-btn>
    </v-card-actions>
  </v-card>
</template>

<script>
export default {
    props : ['todoId'],
    data(){
        return{
            formData : {
                title : "",
                description : "",
                isActive: ""
            },
            status : false,
            loading: false,
            items: [{text: 'Active', value: 'true'}, {text: 'Inactive', value: 'false'}],
        }
    },
    watch:{
        status(newVal){
             //convert select dropdown to true or false
             this.formData.isActive = (newVal === 'true');
        }
    },
    methods:{
        closeThis(){
            this.$emit('closeDialog');
        },
        getDetail(){
            this.$axios.get('/todo/'+this.todoId)
                .then((resp) =>{
                    if (resp.status == 200){
                        if (resp.data.statusCode == 400){
                            this.$emit('showAlert', {type: "error", text: "Invalid Request"});
                        }
                        else if (resp.data){
                            Object.assign(this.formData, resp.data);
                            this.status = resp.data.isActive.toString();
                        }
                    }
                    else{
                        alert("API error");
                    }
                });
        },
        updateData(){  
            if (this.$refs.form.validate()){
                this.loading = true;
                this.$axios.patch('/todo/'+this.todoId, this.formData)
                    .then((resp) => {
                        if (resp.statusCode && resp.statusCode == 400){
                            this.$emit('showAlert', {type: "error", text: resp.message});
                        }
                        else{
                            this.$emit('showAlert', {type: "success", text: "Update Success"});
                            this.$emit('reloadList');
                        }
                        this.loading = false;
                    })
                    .catch((err) =>{
                        alert(err);
                        console.log(err);
                        this.loading = false;
                    });;
            }
        }
    },
    mounted(){
        this.getDetail();
    }
}
</script>

<style>

</style>